//
//  GrowlDisplayController.h
//  Inspire Me
//
//  Created by Dave Batton on 2/20/07.
//  Copyright 2007 Mere Mortal Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GrowlApplicationBridge.h"


@interface GrowlDisplayController : NSObject <GrowlApplicationBridgeDelegate> {
	NSFont *_listImageFont;
	float _listImageHorizontalTextInset;
	float _listImageVerticalTextInset;
	float _listImageBackgroundInset;
	BOOL delegateHasBeenSet;
}


	//Required Display Controller Methods
- (NSString *)name;
- (BOOL)displayPhrase:(NSString *)phrase withDictionary:(NSMutableDictionary *)configurationDictionary;

	// Optional Methods
- (BOOL)canDisplayPhrases;
- (NSImage *)previewForPhrase:(NSString *)phrase withDictionary:(NSDictionary *)aDictionary maxSize:(NSSize)maxSize;
- (NSSize)previewSizeForPhrase:(NSString *)phrase maxSize:(NSSize)maxSize;

	// Notifications
- (void)topicNamesHaveChanged:(NSArray *)topicNames;

	// Growl Related Utilities
- (BOOL)isGrowlInstalled;
- (void)openGrowlPreferencePane;
+ (NSString *)growlPrefPanePath;
+ (NSString *)userPreferencePanesFolder;
+ (NSString *)systemPreferencePanesFolder;
+ (void)growlNotInstalledAlert;
+ (void)growlNotInstalledAlertInWindow:(NSWindow *)aWindow;


@end
