//
//  PhraseDisplayer.h
//  Inspire Me
//
//  Created by Dave Batton on 2/18/07.
//  Copyright 2007 Mere Mortal Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>
@class Topic;
@class Phrase;


@interface PhraseDisplayer : NSObject {
	NSMutableArray *_previousPhrases;
	Phrase *_lastPhraseDisplayed;
	NSDate *_sleepStartTime;
	NSTimer *_currentMessageTimer;
	NSTimer *_phraseDisplayTimer;
	BOOL messageDisplayPaused;
	BOOL _hasBeenStarted;
	
	NSMutableDictionary *_messageTimers;
}


+ (PhraseDisplayer *)sharedPhraseDisplayer;

- (BOOL)displayPhrase:(Phrase *)phraseObject;

	// Timer Triggered Methods
- (void)hideCurrentPhrase;
- (void)hidePhraseForTopic:(Topic *)topic;
- (void)redisplayLastPhrase;

	// Automatic Phrase Display
- (void)displayPhraseNow;
- (void)startDisplayingPhrases;
- (void)spaceOutMessages;
- (void)displayFullTimeMessages;
- (void)displayFullTimeMessagesForTopic:(Topic *)topic;

- (void)hideAllPhrases;

	// Accessor Methods
- (NSManagedObjectContext *)managedObjectContext;
- (void)pushPreviousPhrase:(Phrase *)phrase;
- (Phrase *)popPreviousPhrase;
- (Phrase *)previousPhrase;
- (unsigned)previousPhrasesCount;

- (NSDate *)sleepStartTime;
- (void)setSleepStartTime:(NSDate *)theSleepStartTime;

- (NSTimer *)phraseDisplayTimer;
- (void)setPhraseDisplayTimer:(NSTimer *)aTimer;

	// Notifications
- (void)topicStyleWillChange:(NSNotification *)notification;
- (void)topicFrequencyDidChange:(NSNotification *)notification;
- (void)topicWillBeDeleted:(NSNotification *)notification;
- (void)pauseMessageDisplay:(id)sender;
- (void)resumeMessageDisplay:(id)sender;


@end




@interface  NSObject (DisplayControllerAdditions)
	// Additions
- (BOOL)inspireMeTopicIsConfigurable;
@end
