//
//  PluginController.h
//  Inspire Me
//
//  Created by Dave Batton on 2/18/07.
//  Copyright 2007 Mere Mortal Software. All rights reserved.
//


#import <Cocoa/Cocoa.h>

@class Topic;
@class Phrase;


@interface PluginController : NSObject {
	NSMutableArray *_plugIns;
}


+ (PluginController *)sharedPluginController;

	// Plug-in Loading
- (void)loadPlugIns;
- (void)loadOnePlugIn:(id)controller withIdentifier:(NSString *)identifier;
- (void)unloadPlugIns;

	// Plug-in Access
- (id)displayControllerForStyle:(NSString *)style;
- (id)displayControllerForTopic:(Topic *)topic;
- (id)displayControllerForPhrase:(Phrase *)phrase;
- (void)notifyControllerOfTopicNamesChange:(id)controller;

	// Notifications
//- (void)topicNameDidChange:(NSNotification *)notification;
//- (void)topicWillBeDeleted:(NSNotification *)notification;

	// Accessor Methods
- (NSMutableArray *)plugIns;
- (void)setPlugIns:(NSMutableArray *)configDict;


@end




@interface NSObject (DisplayControllerMethods)
	// Informal Protocol
- (NSString *)name;
- (BOOL)displayPhrase:(NSString *)aString withDictionary:(NSDictionary *)configDict;
- (void)hidePhraseWithDictionary:(NSDictionary *)configDict;
- (BOOL)displayPreviewPhrase:(NSString *)aString withDictionary:(NSDictionary *)configDict;
- (NSTimeInterval)bestDisplayTimeForTextWithLength:(short)characters;
- (NSWindow *)configurationWindowForDictionary:(NSMutableDictionary *)configDict;
- (BOOL)alwaysDisplaysMessage;
- (NSSize)previewSizeForPhrase:(NSString *)phrase maxSize:(NSSize)maxSize;
- (NSImage *)previewForPhrase:(NSString *)phrase withDictionary:(NSDictionary *)configDict maxSize:(NSSize)maxSize;
- (NSWindow *)messageWindow;
@end
